/****************************************************************************
 *
 *   Copyright (C) 2003, 2004 Wolfgang G. Reissnegger, All Rights Reserved
 *
 *   gnagflow@users.sourceforge.net                                    
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the license, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public
 *   License along with this program;  if not, write to the
 *       Free Software Foundation, Inc.,
 *       59 Temple Place - Suite 330,
 *       Boston, MA 02111-1307
 *
 ****************************************************************************/

#include "hotkey.h"

#include "keytab.h"
#include "defs.h"

/******************************************************************************/

// We use an array to store the hotkey handlers. We only support adding hotkeys
// right now, not removing them. Therefore, a list_t *would be overkill...
//
static struct hotkey_d
{
	unsigned int key;
	void (*handler) (void *);
}
hotkey_tab[HOTKEY_TAB_LEN];

static unsigned int last_key = 0;


/******************************************************************************/

void hotkey_add(unsigned int key, void (*handler) (void *))
{
	// Only add, if there is enough space in the table.
	//
	if (last_key < HOTKEY_TAB_LEN)
	{
		hotkey_tab[last_key].key = key;
		hotkey_tab[last_key].handler = handler;

		last_key++;
	}
}


/******************************************************************************/

unsigned int hotkey_exec(unsigned int key, void *data)
{
	unsigned int i;

	for (i = 0; i < last_key; ++i)
	{
		if ((hotkey_tab[i].key == key) && hotkey_tab[i].handler)
		{
			(hotkey_tab[i].handler) (data);
			return KEY_HANDLED;
		}
	}

	return KEY_NOT_HANDLED;
}
