/****************************************************************************
 *
 *   Copyright (C) 2003, 2004 Wolfgang G. Reissnegger, All Rights Reserved
 *
 *   gnagflow@users.sourceforge.net                                    
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the license, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public
 *   License along with this program;  if not, write to the
 *       Free Software Foundation, Inc.,
 *       59 Temple Place - Suite 330,
 *       Boston, MA 02111-1307
 *
 ****************************************************************************/

#ifndef LIST_H_
#define LIST_H_

typedef struct list_d list_t;


list_t *list_add(list_t *node, void *data);
list_t *list_delete_nth(list_t *list, int n);
list_t *list_next(list_t *node);
list_t *list_prev(list_t *node);
void *list_data(list_t *node);
list_t *list_first(list_t *node);
list_t *list_last(list_t *node);
list_t *list_copy(list_t *in);
list_t *list_concat(list_t *in, list_t *newlist);
void list_free(list_t *node);
int list_index_of(list_t *list, void *data);
list_t *list_nth(list_t *list, int n);
int list_len(list_t *list);

#endif
