/****************************************************************************
 *
 *   Copyright (C) 2003, 2004 Wolfgang G. Reissnegger, All Rights Reserved
 *
 *   gnagflow@users.sourceforge.net                                    
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the license, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public
 *   License along with this program;  if not, write to the
 *       Free Software Foundation, Inc.,
 *       59 Temple Place - Suite 330,
 *       Boston, MA 02111-1307
 *
 ****************************************************************************/

#ifndef MENU_H_
#define MENU_H_

#include "fileutil.h"
#include "display.h"

// menu context object, derived from display context
//
typedef struct menu_display_context_d
{
	list_t *start;		// start of the menu list
	int selection;		// currently selected line

	int view_fullpath;	// normal, fullpath view flag

	int display_top_line;	// entry display at first line

	int left_margin;	// Left margin of menu display


// These are accessor macros. Make sure that ctx is of type
// menu_display_context_t* when using these...
//
#define c_start                 ((menu_display_context_t *) ctx)->start
#define c_selection             ((menu_display_context_t *) ctx)->selection
#define c_view_fullpath         ((menu_display_context_t *) ctx)->view_fullpath
#define c_display_top_line      ((menu_display_context_t *) ctx)->display_top_line
#define c_left_margin           ((menu_display_context_t *) ctx)->left_margin
}
menu_display_context_t;


/******************************************************************************/

#define TYPE_MENU       	0x8376afda
#define TYPE_SONGLIST_MENU	0xfd9817a8


/******************************************************************************/

screen_t *menu_new();
screen_t *menu_new_from_filelist(list_t *fentry_list);
screen_t *menu_new_from_dir(const char *dir);
file_entry_t *menu_add(screen_t * screen, const char *name, void (*h) (void *));

#endif
