/****************************************************************************
 *
 *   Copyright (C) 2003, 2004 Wolfgang G. Reissnegger, All Rights Reserved
 *
 *   gnagflow@users.sourceforge.net                                    
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the license, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public
 *   License along with this program;  if not, write to the
 *       Free Software Foundation, Inc.,
 *       59 Temple Place - Suite 330,
 *       Boston, MA 02111-1307
 *
 ****************************************************************************/

#include "fileutil.h"
#include "defs.h"
#include "player.h"


static int	dummy_init()			{ return -1; }
static int	dummy_fd()			{ return 0; }
static int	dummy_is_playing()		{ return FALSE; }
static int	dummy_is_paused()		{ return FALSE; }
static int	dummy_has_ended()		{ return FALSE; }
static int	dummy_current_frame()		{ return -1; }
static int	dummy_sample_rate()		{ return -1; }
static int	dummy_bit_rate()		{ return -1; }
static void	dummy_exit()			{ }
static void	dummy_play(const char *path)	{ }
static int	dummy_stop()			{ return -1; }
static int	dummy_pause()			{ return -1; }
static void	dummy_fwd()			{ }
static void	dummy_rew()			{ }
static void	dummy_goto_frame(int frame)	{ }
static int	dummy_recv_message()		{ return -1; }
static const char *dummy_time()			{ return "no time"; }
static const char *dummy_time_remaining()	{ return "no time"; }

/******************************************************************************/

static player_if_t	player_reg =
{
	.init		= dummy_init,
	.exit		= dummy_exit,

	.fd		= dummy_fd,

	.play		= dummy_play,
	.stop		= dummy_stop,
	.pause		= dummy_pause,
	.fwd		= dummy_fwd,
	.rew		= dummy_rew,
	.goto_frame	= dummy_goto_frame,

	.recv_message	= dummy_recv_message,
	.current_frame	= dummy_current_frame,
	.sample_rate	= dummy_sample_rate,
	.bit_rate	= dummy_bit_rate,

	.is_playing	= dummy_is_playing,
	.is_paused	= dummy_is_paused,
	.has_ended	= dummy_has_ended,

	.time		= dummy_time,
	.time_remaining	= dummy_time_remaining,
};

static void __attribute__ ((constructor)) dummy_constructor(void)
{
	player_register(FILE_TYPE_UNKNOWN, &player_reg);
}

