/****************************************************************************
 *
 *   Copyright (C) 2003, 2004 Wolfgang G. Reissnegger, All Rights Reserved
 *
 *   gnagflow@users.sourceforge.net                                    
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the license, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public
 *   License along with this program;  if not, write to the
 *       Free Software Foundation, Inc.,
 *       59 Temple Place - Suite 330,
 *       Boston, MA 02111-1307
 *
 ****************************************************************************/

#include "search_menu.h"

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include "display.h"
#include "menu.h"
#include "info.h"
#include "hotkey.h"
#include "util.h"

#include "search.h"


/******************************************************************************/

static void search_all_files(void *data)
{
	display_push(search_new(NULL));
}


/******************************************************************************/

void search_menu(void *data)
{
	screen_t *search_menu = menu_new();

	menu_add(search_menu, "Search All Files", search_all_files);
	menu_add(search_menu, "Search Sub-List", ni);

	display_push(search_menu);
}

/******************************************************************************/

void search_menu_init()
{
	// Initialize hotkey handlers
	//
	hotkey_add(KEY_SEARCH_MENU, search_menu);
	hotkey_add(KEY_SEARCH_MENU_SEARCH_ALL, search_all_files);
}
